/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this 
  notice you can do whatever you want with this stuff. 
  If we meet some day, and you think this stuff is worth it, 
  you can buy me a beer in return.
----------------------------------------------------------*/ 


#include "includes.h"



/*
http://polynomialregression.drque.net/online.php
400	11
450	27
500	44
550	61.5
600	79.5
700	113.5
750	129.5
800	145.5
850	162
900	178.5
950	196
1000	212.5
1050	230.5
1100	247.5

*/
const float gs_calibration[]=
{
    -83.48817131444297,
    0.05695739302570269,
    0.0006837123918389026,
    -6.9701219546382e-7,
    2.5222455563e-10
};
/*
0	0
50	4.5
75	11
100	17.5
125	26
150	35.5
175	45
200	54.5
225	64.5
250	74.5
300	93.5
350	111
400	128.5
450	145.5
500	162.5
550	179.5
600	196.5
650	213
700	229
750	243.5
*/

const float ias_calibration[]=
{
    0.04284027761554301,
    -0.031001233769834435,
    0.002878906041765201,
    -0.00000931417551891078,
    1.479563418962e-8,
    -1.127692798e-11,
    3.21021e-15
};

float polynom_calc(int order,float x, float const *polinom_constants)
{
    float polinom_summ = 0;
    float product = 1;
    int i;
    for(i=0; i<order; i++)
    {
        polinom_summ += product * polinom_constants[i];
        product *= x;
    }
    return polinom_summ;
}


int loop = 1, keypress;
float scale_factor;
HDC hdc;
FILE *inifile;
BITMAP *scrat, *frame,
       *ground,*ias,
       *ias_bg,*blanker,
       *vref,
       *v_r,*v_2
       ;
float gs = 0;
float is = 0;
float v_ref = 0;
float vr = 0;
float v2 = 0;



int initialise_window( void );
int connect_to_sim( void );
int update_display( void );
int create_bitmaps( void );

int act_on_keypress( void );
int close_program( void );
void exit_hook (void );


int main(int argc, char *argv[] )
{

    STARTUPINFO cif;
    PROCESS_INFORMATION pi;
    load_config();






    if(0 == strcmp(config.console,"off") && argc == 1)
    {
        ZeroMemory(&cif,sizeof(STARTUPINFO));
        if(CreateProcess(NULL,"ias.exe AS_DAEMON",
                         NULL,NULL,FALSE,CREATE_NO_WINDOW,NULL,NULL,&cif,&pi))

        {
            CloseHandle( pi.hProcess );
            CloseHandle( pi.hThread );
            exit(0);
        }
    }

    if(config.uplink_port)
        server_start(config.uplink_port);


    if(config.downlink_port)
    {
        udp_sender_start(config.downlink_port, config.downlink_ip);
    }


    initialise_window();


    if( create_bitmaps() == -1 )
    {
        textprintf_centre(screen, font, config.size / 2, config.size * 0.15, 65535,  "*** Error ***" );
        textprintf_centre(screen, font, config.size / 2, config.size * 0.40, 65535,  "No Graphics files" );
        textprintf_centre(screen, font, config.size / 2, config.size * 0.65, 65535,  "Press Key to Exit" );
        readkey();
        close_program();
        return( -1 );
    }

    update_display();

    while( loop == 1 )
    {

        while( keypressed() )
        {
            act_on_keypress();
            update_display();
        }
        clear_keybuf();
        update_display();
    }

    save_config();
    close_program();
    return (0);
}
END_OF_MAIN()

int initialise_window( void )
{
    hdc = GetDC(NULL);
    int screen_colour_depth = GetDeviceCaps (hdc, BITSPIXEL );

    if (allegro_init() != 0) return 1; //Initialise Allegro
    install_keyboard();

    set_color_depth(screen_colour_depth);


    if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0) != 0)
    {
        if (set_gfx_mode(GFX_SAFE, 800, 600, 0, 0) != 0)
        {
            set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
            allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
            return 1;
        }
    }

    SetWindowPos(win_get_window(), HWND_TOPMOST,
                 config.x_pos,
                 config.y_pos,
                 config.size+6,
                 config.size+25,
                 SWP_ASYNCWINDOWPOS);

    set_display_switch_mode(SWITCH_BACKGROUND);
    scale_factor = ((float)config.size / 400);

    set_window_close_hook(exit_hook);
    return( 0 );
}


int update_display( void )

{
    int size = config.size;
    int mouse_state = mouse_b;

    stretch_blit( ias_bg, scrat, 0,0,400,400,0,0,size,size);

    pivot_scaled_sprite(scrat,
                        ground,
                        size / 2,
                        size / 2,
                        29, 29,
                        ftofix(polynom_calc(5,gs, gs_calibration)) ,
                        ftofix(scale_factor*0.5));

    pivot_scaled_sprite(scrat,
                        blanker,
                        size / 2,
                        size / 2,

                        33, 24,
                        ftofix(0) ,
                        ftofix(scale_factor*0.5));


    pivot_scaled_sprite(scrat,
                        vref,
                        size / 2,
                        size / 2,
                        30, 354,
                        ftofix(polynom_calc(7,v_ref, ias_calibration)),
                        ftofix(scale_factor*0.5));


    pivot_scaled_sprite(scrat,
                        v_r,
                        size / 2,
                        size / 2,
                        30, 354,
                        ftofix(polynom_calc(7,vr, ias_calibration)),
                        ftofix(scale_factor*0.5));

    pivot_scaled_sprite(scrat,
                        v_2,
                        size / 2,
                        size / 2,
                        30, 354,
                        ftofix(polynom_calc(7,v2, ias_calibration)),
                        ftofix(scale_factor*0.5));


    pivot_scaled_sprite(scrat,
                        ias,
                        size / 2,
                        size / 2,
                        30, 335,
                        ftofix(polynom_calc(7,is, ias_calibration)) ,
                        ftofix(scale_factor*0.5));


    rotate_scaled_sprite(scrat, frame, 00, 00, ftofix(128) , ftofix(scale_factor*0.666666666));

    if(console_flag)
        printf("ias: %f   gs: %f   vref: %f\n",
               is,
               gs,
               v_ref
              );

    textprintf_ex(scrat, font, 5, 5, makecol(255, 255, 000),-1,
                  "%3.0f kias",is/1.852
                 );


    textprintf_ex(scrat, font, size-70, 5, makecol(000, 255, 000),-1,
                  "%3.0f km/h",
                  is
                 );


    if(gs>=400)
    {
        textprintf_ex(scrat, font, 5, size-15, makecol(255, 255, 000),-1,
                      "%3.0f ktas",gs/1.852
                     );

        textprintf_ex(scrat, font, size-70, size-15, makecol(000, 255, 000),-1,
                      "%3.0f km/h",
                      gs
                     );
    }
    else
    {
        textprintf_ex(scrat, font, 5, size-15, makecol(255, 255, 000),-1,
                      "--- ktas"
                     );

        textprintf_ex(scrat, font, size-70, size-15, makecol(000, 255, 000),-1,
                      "--- km/h"
                     );

    }


    blit(scrat, screen, 0, 0, 0, 0, size, size);
    Sleep(50);
    return( 0 );
}

int create_bitmaps( void )
{
    int size = config.size;
    scrat = create_bitmap(size, size);

    if( (v_r = load_bitmap( "..\\Resources\\ias\\vrot.bmp", v_r)) == NULL ) return( -1 );
    if( (v_2 = load_bitmap( "..\\Resources\\ias\\v2.bmp", v_2 )) == NULL ) return( -1 );


    if( (vref = load_bitmap( "..\\Resources\\ias\\vref.bmp", vref )) == NULL ) return( -1 );
    if( (ias_bg = load_bitmap( "..\\Resources\\ias\\kus_bg.bmp", ias_bg )) == NULL ) return( -1 );
    if( (ground = load_bitmap( "..\\Resources\\ias\\ground.bmp", ground )) == NULL ) return( -1 );
    if( (frame =  load_bitmap( "..\\Resources\\ias\\frame.bmp", frame )) == NULL ) return( -1 );
    if( (ias = load_bitmap( "..\\Resources\\ias\\ias.bmp", ias )) == NULL ) return( -1 );
    if( (blanker = load_bitmap( "..\\Resources\\ias\\blanker.bmp", blanker )) == NULL ) return( -1 );
    return( 0 );
}

int act_on_keypress( void )
{
    RECT rect;
    if (GetWindowRect(win_get_window(), &rect))
    {
        config.x_pos = (int)rect.left;
        config.y_pos = (int)rect.top;
    }
    keypress = readkey();
    switch (keypress)
    {

    case 6778: //z
        gs -= 10;
        break;

    case 6264: //x
        gs += 10;
        break;



    case 867: //c
        is -= 10;
        break;


    case 5750: //v
        is += 10;
        break;


    case 4465 : //q
        v_ref -= 1;

        break;

    case 353: //a
        break;

    case 6007 : //w
        v_ref += 1;
        break;

    case 1381: //e
        break;


    case 2409:         //i pressed ( increase size )
        if ( config.size < 600 ) config.size+=1;
        destroy_bitmap( scrat );
        scrat = create_bitmap(config.size, config.size);
        SetWindowPos(win_get_window(),
                     HWND_TOPMOST,
                     config.x_pos,
                     config.y_pos,
                     config.size+6,
                     config.size+25,
                     SWP_NOZORDER);

        scale_factor = ((float)config.size / 400);
        break;

    case 1124:         //d pressed ( decrease size )
        if( config.size > 142 ) config.size-=1;
        destroy_bitmap( scrat );
        scrat = create_bitmap(config.size, config.size);
        SetWindowPos(win_get_window(),
                     0,
                     config.x_pos,
                     config.y_pos,
                     config.size+6,
                     config.size+25,
                     SWP_NOZORDER);
        scale_factor = ((float)config.size / 400);
        break;
    }
    return( 0 );
}
int close_program( void )
{
    allegro_exit();
    return( 0 );
}
void exit_hook( void )
{
    loop = 0;
}

void cb_on_data(int block_id, float *data)
{
    int i;

    switch(block_id)
    {
    case 63:

        v_ref = 146.0 + 4.0 * data[4] / 2204.6;

        vr = 92.222 + 5.556* data[4] / 2204.6;

        v2 = 111.182 + 5.882* data[4] / 2204.6;

        break;

    case 3:
        is = 1.852*data[0];


        gs = 1.852*data[2];
        if(gs <= 399.0 || gs >= 1100.0)
        {
            gs = 370.0;
        }



        break;

    }




}








