/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this 
  notice you can do whatever you want with this stuff. 
  If we meet some day, and you think this stuff is worth it, 
  you can buy me a beer in return.
----------------------------------------------------------*/ 

#include "includes.h"


int loop = 1, keypress;
float scale_factor;
char buffer[100];
DWORD dwResult;
HDC hdc;
FILE *inifile;
BITMAP *scrat, *frame, *vsi_ptr,*vsi_bg;
float vsi = 0;

int initialise_window( void );
int connect_to_sim( void );
int update_display( void );
int create_bitmaps( void );

int act_on_keypress( void );
int close_program( void );
void exit_hook (void );


int main(int argc, char *argv[] )
{

    STARTUPINFO cif;
    PROCESS_INFORMATION pi;
    load_config();






    if(0 == strcmp(config.console,"off") && argc == 1)
    {

        ZeroMemory(&cif,sizeof(STARTUPINFO));
        if(CreateProcess(NULL,"vsi.exe AS_DAEMON",
                         NULL,NULL,FALSE,CREATE_NO_WINDOW,NULL,NULL,&cif,&pi))

        {
            CloseHandle( pi.hProcess );
            CloseHandle( pi.hThread );
            exit(0);
        }
    }

    if(config.uplink_port)
        server_start(config.uplink_port);


    if(config.downlink_port)
    {
        udp_sender_start(config.downlink_port, config.downlink_ip);
    }


    initialise_window();


    if( create_bitmaps() == -1 )
    {
        textprintf_centre(screen, font, config.size / 2, config.size * 0.15, 65535,  "*** Error ***" );
        textprintf_centre(screen, font, config.size / 2, config.size * 0.40, 65535,  "No Graphics files" );
        textprintf_centre(screen, font, config.size / 2, config.size * 0.65, 65535,  "Press Key to Exit" );
        readkey();
        close_program();
        return( -1 );
    }

    update_display();

    while( loop == 1 )
    {

        while( keypressed() )
        {
            act_on_keypress();
            update_display();
        }
        clear_keybuf();
        update_display();
    }
    save_config();
    close_program();
    return (0);
}
END_OF_MAIN()

int initialise_window( void )
{
    hdc = GetDC(NULL);
    int screen_colour_depth = GetDeviceCaps (hdc, BITSPIXEL );

    if (allegro_init() != 0) return 1; //Initialise Allegro
    install_keyboard();

    set_color_depth(screen_colour_depth);


    if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0) != 0)
    {
        if (set_gfx_mode(GFX_SAFE, 800, 600, 0, 0) != 0)
        {
            set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
            allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
            return 1;
        }
    }

    SetWindowPos(win_get_window(), HWND_TOPMOST,
                 config.x_pos,
                 config.y_pos,
                 config.size+6,
                 config.size+25,
                 SWP_ASYNCWINDOWPOS);

    set_display_switch_mode(SWITCH_BACKGROUND);
    scale_factor = ((float)config.size / 400);

    set_window_close_hook(exit_hook);
    return( 0 );
}


const float vsi_calibration[]=
{
    -0.1009390487481379,
    6.0038371038968155,
    0.0007780267460274704,
    -0.003017548757764516,
    2.0303756716493e-7,
    0.00000119855045693528
};


float polynom_calc(int order,float x, float const *polinom_constants)
{
    float polinom_summ = 0;
    float product = 1;
    int i;
    for(i=0; i<order; i++)
    {
        polinom_summ += product * polinom_constants[i];
        product *= x;
    }
    return polinom_summ;
}



int update_display( void )

{
    int size = config.size;
    int mouse_state = mouse_b;

    stretch_blit( vsi_bg, scrat, 0,0,400,400,0,0,size,size);


    pivot_scaled_sprite(scrat,
                        vsi_ptr,
                        size / 2,
                        size / 2,
                        151, 11,
                        ftofix(polynom_calc(6,vsi, vsi_calibration)),
                        ftofix(scale_factor));


    rotate_scaled_sprite(scrat, frame, 00, 00, ftofix(128) , ftofix(scale_factor*0.666666666));

    if(console_flag)
        printf("vsi: %f\n", vsi);

    textprintf_ex(scrat, font, 5, 5, makecol(255, 255, 000),-1,
                  "%5.0f fpm",vsi*196.8504
                 );

    textprintf_ex(scrat, font, size-70, 5, makecol(000, 255, 000),-1,
                  "%3.2f m/s",
                  vsi
                 );

    blit(scrat, screen, 0, 0, 0, 0, size, size);
    Sleep(50);
    return( 0 );
}

int create_bitmaps( void )
{
    int size = config.size;
    scrat = create_bitmap(size, size);
    if( (vsi_bg = load_bitmap( "..\\Resources\\vsi\\vsi_bg.bmp", vsi_bg )) == NULL ) return( -1 );
    if( (frame =  load_bitmap( "..\\Resources\\vsi\\frame.bmp", frame )) == NULL ) return( -1 );
    if( (vsi_ptr = load_bitmap( "..\\Resources\\vsi\\vsi_ptr.bmp", vsi_ptr )) == NULL ) return( -1 );
    return( 0 );
}

int act_on_keypress( void )
{
    RECT rect;
    if (GetWindowRect(win_get_window(), &rect))
    {
        config.x_pos = (int)rect.left;
        config.y_pos = (int)rect.top;
    }
    keypress = readkey();
    switch (keypress)
    {

    case 6778: //z
        vsi -= 0.5;
        break;

    case 6264: //x
        vsi += 0.5;
        break;



    case 867: //c
        break;


    case 5750: //v
        break;


    case 4465 : //q
        break;

    case 353: //a
        break;

    case 6007 : //w
        break;

    case 1381: //e
        break;


    case 2409:         //i pressed ( increase size )
        if ( config.size < 600 ) config.size+=1;
        destroy_bitmap( scrat );
        scrat = create_bitmap(config.size, config.size);
        SetWindowPos(win_get_window(),
                     HWND_TOPMOST,
                     config.x_pos,
                     config.y_pos,
                     config.size+6,
                     config.size+25,
                     SWP_NOZORDER);

        scale_factor = ((float)config.size / 400);
        break;

    case 1124:         //d pressed ( decrease size )
        if( config.size > 142 ) config.size-=1;
        destroy_bitmap( scrat );
        scrat = create_bitmap(config.size, config.size);
        SetWindowPos(win_get_window(),
                     0,
                     config.x_pos,
                     config.y_pos,
                     config.size+6,
                     config.size+25,
                     SWP_NOZORDER);
        scale_factor = ((float)config.size / 400);
        break;
    }
    return( 0 );
}
int close_program( void )
{
    allegro_exit();
    return( 0 );
}
void exit_hook( void )
{
    loop = 0;
}

void cb_on_data(int block_id, float *data)
{
    int i;

    switch(block_id)
    {
    case 4:
        vsi = data[2] / 196.8504;

        break;

    }




}








